﻿using System;
using System.Drawing;
using System.Linq;
using System.Windows.Forms;
using System.Diagnostics;

namespace Course_Project.Forms
{
    public partial class AdminPanel : Form
    {
        
        public AdminPanel()
        {
            InitializeComponent();
        }
      
        private void AdminPanel_Load(object sender, EventArgs e)
        {
            // TODO: данная строка кода позволяет загрузить данные в таблицу "courseDataSet.Users". При необходимости она может быть перемещена или удалена.
            this.usersTableAdapter.Fill(this.courseDataSet.Users);

        }

        private void button1_Click(object sender, EventArgs e)
        {
            using (var db = new Database())
            {
                if (string.IsNullOrEmpty(LoginBox.Text) | string.IsNullOrEmpty(PasswordBox.Text) || string.IsNullOrEmpty(RoleBox.Text))
                {

                    UserAddWarnLabel.Text = "Проверьте заполненность полей";
                }
                else
                {
                    if (PasswordBox.Text == PasswordConfirmBox.Text)
                    {
                        bool userExists = db.Users.Any(u => u.Login == LoginBox.Text);
                        if (!userExists)
                        {
                            db.Database.ExecuteSqlCommand($"INSERT INTO Users (Login, Password, UserGroup)\nVALUES('{LoginBox.Text}','{PasswordBox.Text}', '{RoleBox.Text}');");
                            UserAddWarnLabel.ForeColor = Color.Green;
                            UserAddWarnLabel.Text = "Пользователь добавлен";
                            this.usersTableAdapter.Fill(this.courseDataSet.Users);
                        }
                        else
                        {
                            UserAddWarnLabel.Text = "Пользователь существует";
                        }
                    }
                    else
                    {
                        UserAddWarnLabel.Text = "Пароли не совпадают";
                    }
                }
            }
        }

   
        protected override bool ProcessCmdKey(ref Message msg, Keys keyData)
        {

            //Обработка нажатия Enter для подтверждения формы
            if (keyData == (Keys.Enter))
            {
                button1.PerformClick();
                return true;
            }
            return base.ProcessCmdKey(ref msg, keyData);
        }


        private void deleteUserButton_Click(object sender, EventArgs e)
        {

            using (var db = new Database())
            {
                if (dataGridView1.CurrentCell.Value.ToString() == null)
                {
                    MessageBox.Show("Не выбран пользователь для удаления!", "Ошибка!", MessageBoxButtons.OK, MessageBoxIcon.Exclamation, MessageBoxDefaultButton.Button1);

                }
                else
                {
                    db.Database.ExecuteSqlCommand($"DELETE FROM Users WHERE Login='{dataGridView1.CurrentCell.Value.ToString()}'");
                    this.usersTableAdapter.Fill(this.courseDataSet.Users);
                }

            }
        }

        private void ChangePassButton_Click(object sender, EventArgs e)
        {
            using (var db = new Database())
            {
                if (string.IsNullOrEmpty(resetPassLoginBox.Text) | string.IsNullOrEmpty(resetPassNewPass.Text) || string.IsNullOrEmpty(resetPassNewConfirm.Text))
                {
                    UserAddWarnLabel.Text = "Проверьте заполненность полей";
                }
                else
                {
                    if (resetPassNewPass.Text == resetPassNewConfirm.Text)
                    {
                        bool userExists = db.Users.Any(u => u.Login == resetPassLoginBox.Text);
                        if (userExists)
                        {
                            db.Database.ExecuteSqlCommand($"UPDATE Users SET Password = '{resetPassNewPass.Text}' WHERE Login = '{resetPassLoginBox.Text}'");
                            ChangePassWarn.ForeColor = Color.Green;
                            ChangePassWarn.Text = "Пароль изменен";
                            this.usersTableAdapter.Fill(this.courseDataSet.Users);
                        }
                        else
                        {
                            ChangePassWarn.Text = "Пользователь не существует";
                        }
                    }
                    else
                    {
                        ChangePassWarn.Text = "Пароли не совпадают";
                    }
                }
            }
        }


        private void выходToolStripMenuItem_Click(object sender, EventArgs e)
        {
            this.Close();
            LoginForm LoginForm = new LoginForm();
            LoginForm.Show();
        }
    }
}