﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using Course_Project.Modules;

namespace Course_Project
{
    public partial class LoginForm : Form
    {
        public LoginForm()
        {
            InitializeComponent();
            //Модуль: Генератор форм
            GenForms GenForms = new GenForms();
        }

        protected override bool ProcessCmdKey(ref Message msg, Keys keyData)
        {
            //うんち
            if (keyData == (Keys.Control | Keys.Alt | Keys.Insert))
            {
                GenForms.EggForm();
                return true;
            }
            //Обработка нажатия Enter для подтверждения формы
            if (keyData == (Keys.Enter))
            {
                LoginButton.PerformClick();
                return true;
            }
            return base.ProcessCmdKey(ref msg, keyData);
        }
       
           
       
    private void LoginButton_Click(object sender, EventArgs e)
        {
            if (LoginAsAdminRadio.Checked == true)
            {
                GenForms.AdminPanel();
                this.Hide();
            }
            if (LoginAsOperRadio.Checked == true)
            {
                GenForms.OperatorPanel();
                this.Hide();
            }

            if (string.IsNullOrEmpty(LoginBox.Text) || string.IsNullOrEmpty(PasswordBox.Text))
            {
                LoginWarnLabel.Text = "Проверьте поля";
                return;
            }
          
            using (var db = new Database())
            {
              
                var user = db.Users.AsNoTracking().FirstOrDefault(u => u.Login == LoginBox.Text && u.Password == PasswordBox.Text);

                if (user == null)
                {
                    LoginWarnLabel.Text = "Пользователя не существует";
                    return;
                }
               
                    switch (user.UserGroup)
                    {
                        case "Администратор":
                        GenForms.AdminPanel();
                        this.Hide();
                            break;
                        case "Оператор":
                        GenForms.OperatorPanel ();
                        this.Hide();
                        break;
                    }
                
               
            }
          
        }

        private void LoginForm_Load(object sender, EventArgs e)
        {

        }
    }
    }


      
