﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using Course_Project.Modules;

namespace Course_Project
{
    public partial class LoginForm : Form
    {
        public LoginForm()
        {
            InitializeComponent();
            //Модуль: Генератор форм
            GenForms GenForms = new GenForms();
        }

        protected override bool ProcessCmdKey(ref Message msg, Keys keyData)
        {
           
           
            //Обработка нажатия Enter для подтверждения формы
            if (keyData == (Keys.Enter))
            {
                LoginButton.PerformClick();
                return true;
            }
            return base.ProcessCmdKey(ref msg, keyData);
        }

        private void LoginButton_Click(object sender, EventArgs e)
        {

            //Проверка пустоты полей
            if (string.IsNullOrEmpty(LoginBox.Text) || string.IsNullOrEmpty(PasswordBox.Text))
            {
                LoginWarnLabel.Text = "Проверьте поля";
                return;
            }

            using (var db = new Database())
            {
                //Ищем пользователя в базе
                var user = db.Users.AsNoTracking().FirstOrDefault(u => u.Login == LoginBox.Text && u.Password == PasswordBox.Text);
                //Если нет
                if (user == null)
                {
                    LoginWarnLabel.Text = "Неверная пара логин/пароль";
                    return;
                }

                //Если есть
                switch (user.UserGroup) //Проверяем группу
                {
                    case "Администратор":
                        switch (RoleCombo.SelectedIndex)
                        {
                            case 0:
                                {
                                    GenForms.OperatorPanel();
                                    this.Hide();
                                }
                                break;
                            case 1:
                                {
                                    GenForms.AdminPanel();
                                    this.Hide();
                                }
                                break;

                        }
                        break;
                    case "Оператор":
                        switch (RoleCombo.SelectedIndex)
                        {
                            case 0:
                                {
                                    GenForms.OperatorPanel();
                                    this.Hide();
                                }
                                break;
                            case 1:
                                {
                                    LoginWarnLabel.Text = "Нет доступа";
                                }
                                break;

                        }
                        break;
                }
            }
        }

        private void LoginForm_Load(object sender, EventArgs e)
        {
            RoleCombo.SelectedIndex = 0;
        }
    }
}